diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/he-phy.cc ns-3.43/src/wifi/model/he/he-phy.cc
--- ns-3.42/src/wifi/model/he/he-phy.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/he-phy.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1846,11 +1882,30 @@
         break;
     }
 
-    auto numBandsInBand = static_cast<size_t>(bandWidth * 1e6 / subcarrierSpacing);
+    const auto numBandsInBand = static_cast<size_t>(bandWidth * 1e6 / subcarrierSpacing);
     centerFrequencyIndex += numBandsInBand * bandIndex;
-
-    convertedSubcarriers.first = centerFrequencyIndex + subcarrierRange.first;
-    convertedSubcarriers.second = centerFrequencyIndex + subcarrierRange.second;
+    // start and stop subcarriers might be in different frequency segments, hence define a low and a
+    // high center frequency
+    auto centerFrequencyIndexLow = centerFrequencyIndex;
+    auto centerFrequencyIndexHigh = centerFrequencyIndex;
+    if (centerFrequencies.size() > 1)
+    {
+        const auto numBandsBetweenSegments =
+            SpectrumWifiPhy::GetNumBandsBetweenSegments(centerFrequencies,
+                                                        totalWidth,
+                                                        subcarrierSpacing);
+        if (subcarrierRange.first > 0)
+        {
+            centerFrequencyIndexLow += numBandsBetweenSegments;
+        }
+        if (subcarrierRange.second > 0)
+        {
+            centerFrequencyIndexHigh += numBandsBetweenSegments;
+        }
+    }
+    convertedSubcarriers.emplace_back(centerFrequencyIndexLow + subcarrierRange.first,
+                                      centerFrequencyIndexHigh + subcarrierRange.second);
+    ++bandIndex;
     return convertedSubcarriers;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/he-phy.h ns-3.43/src/wifi/model/he/he-phy.h
--- ns-3.42/src/wifi/model/he/he-phy.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/he-phy.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Rediet <getachew.redieteab@orange.com>
  *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy and
@@ -27,6 +16,7 @@
 #include "ns3/callback.h"
 #include "ns3/vht-phy.h"
 #include "ns3/wifi-phy-band.h"
+#include "ns3/wifi-types.h"
 
 #include <optional>
 
@@ -52,7 +42,7 @@
  */
 struct HeSigAParameters
 {
-    double rssiW;     ///< RSSI in W
+    dBm_u rssi;       ///< RSSI
     uint8_t bssColor; ///< BSS color
 };
 
@@ -105,14 +95,14 @@
                               Time rxDuration) override;
     void CancelAllEvents() override;
     uint16_t GetStaId(const Ptr<const WifiPpdu> ppdu) const override;
-    uint16_t GetMeasurementChannelWidth(const Ptr<const WifiPpdu> ppdu) const override;
+    MHz_u GetMeasurementChannelWidth(const Ptr<const WifiPpdu> ppdu) const override;
     void StartTx(Ptr<const WifiPpdu> ppdu) override;
-    Time CalculateTxDuration(WifiConstPsduMap psduMap,
+    Time CalculateTxDuration(const WifiConstPsduMap& psduMap,
                              const WifiTxVector& txVector,
                              WifiPhyBand band) const override;
     void SwitchMaybeToCcaBusy(const Ptr<const WifiPpdu> ppdu) override;
-    double GetCcaThreshold(const Ptr<const WifiPpdu> ppdu,
-                           WifiChannelListType channelType) const override;
+    dBm_u GetCcaThreshold(const Ptr<const WifiPpdu> ppdu,
+                          WifiChannelListType channelType) const override;
     void NotifyCcaBusy(const Ptr<const WifiPpdu> ppdu,
                        Time duration,
                        WifiChannelListType channelType) override;
@@ -193,12 +183,12 @@
      */
     WifiSpectrumBandInfo GetNonOfdmaBand(const WifiTxVector& txVector, uint16_t staId) const;
     /**
-     * Get the width in MHz of the non-OFDMA portion of an HE TB PPDU
+     * Get the width of the non-OFDMA portion of an HE TB PPDU
      *
      * \param ru the RU in which the HE TB PPDU is sent
-     * \return the width in MHz of the non-OFDMA portion of an HE TB PPDU
+     * \return the width of the non-OFDMA portion of an HE TB PPDU
      */
-    uint16_t GetNonOfdmaWidth(HeRu::RuSpec ru) const;
+    MHz_u GetNonOfdmaWidth(HeRu::RuSpec ru) const;
 
     /**
      * \return the UID of the HE TB PPDU being received
@@ -215,15 +205,15 @@
     void SetTrigVector(const WifiTxVector& trigVector, Time validity);
 
     /**
-     * Get the center frequency of the non-HE portion of the current TxVector for the
-     * given STA-ID.
-     * Note this method is only to be used for UL MU.
+     * Get the center frequency per segment of the non-HE portion of the current PPDU for the given
+     * STA-ID. Note this method is only to be used for UL MU.
      *
-     * \param txVector the TXVECTOR that has the RU allocation
+     * \param ppdu the PPDU
      * \param staId the STA-ID of the station taking part of the UL MU
-     * \return the center frequency in MHz corresponding to the non-HE portion of the HE TB PPDU
+     * \return the center frequency corresponding to the non-HE portion of the HE TB PPDU
      */
-    uint16_t GetCenterFrequencyForNonHePart(const WifiTxVector& txVector, uint16_t staId) const;
+    std::vector<MHz_u> GetCenterFrequenciesForNonHePart(const Ptr<const WifiPpdu> ppdu,
+                                                        uint16_t staId) const;
 
     /**
      * Sets the OBSS-PD algorithm.
@@ -366,15 +356,15 @@
      * and is mainly used as a callback for WifiMode operation.
      *
      * \param mcsValue the HE MCS index
-     * \param channelWidth the considered channel width in MHz
-     * \param guardInterval the considered guard interval duration in nanoseconds
+     * \param channelWidth the considered channel width
+     * \param guardInterval the considered guard interval duration
      * \param nss the considered number of stream
      *
      * \return the physical bit rate of this signal in bps.
      */
     static uint64_t GetPhyRate(uint8_t mcsValue,
-                               uint16_t channelWidth,
-                               uint16_t guardInterval,
+                               MHz_u channelWidth,
+                               Time guardInterval,
                                uint8_t nss);
     /**
      * Return the PHY rate corresponding to
@@ -403,14 +393,14 @@
      * streams.
      *
      * \param mcsValue the MCS index
-     * \param channelWidth the channel width in MHz
-     * \param guardInterval the guard interval duration in nanoseconds
+     * \param channelWidth the channel width
+     * \param guardInterval the guard interval duration
      * \param nss the number of spatial streams
      * \return the data bit rate in bps.
      */
     static uint64_t GetDataRate(uint8_t mcsValue,
-                                uint16_t channelWidth,
-                                uint16_t guardInterval,
+                                MHz_u channelWidth,
+                                Time guardInterval,
                                 uint8_t nss);
     /**
      * Calculate the rate in bps of the non-HT Reference Rate corresponding
@@ -441,22 +431,34 @@
     static WifiMode CreateHeMcs(uint8_t index);
 
     /**
-     * \param bandWidth the width (MHz) of the band used for the OFDMA transmission. Must be
-     *                  a multiple of 20 MHz
-     * \param guardBandwidth width of the guard band (MHz)
-     * \param subcarrierSpacing the subcarrier spacing (MHz)
+     * \param guardInterval the guard interval duration
+     * \return the symbol duration
+     */
+    static Time GetSymbolDuration(Time guardInterval);
+
+    /**
+     * \param bandWidth the width of the band used for the OFDMA transmission. Must be a multiple of
+     * 20 MHz
+     * \param guardBandwidth width of the guard band
+     * \param centerFrequencies the center frequency of each segment
+     * \param totalWidth the width of the operating channel
+     * \param subcarrierSpacing the subcarrier spacing
      * \param subcarrierRange the subcarrier range of the HE RU
      * \param bandIndex the index (starting at 0) of the band within the operating channel
      * \return the converted subcarriers
      *
      * This is a helper function to convert HE RU subcarriers, which are relative to the center
-     * frequency subcarrier, to the indexes used by the Spectrum model.
+     * frequency subcarrier, to the indexes used by the Spectrum model. The size of the returned
+     * vector corresponds to the number of segments covered by the HE RU.
      */
-    static WifiSpectrumBandIndices ConvertHeRuSubcarriers(uint16_t bandWidth,
-                                                          uint16_t guardBandwidth,
-                                                          uint32_t subcarrierSpacing,
-                                                          HeRu::SubcarrierRange subcarrierRange,
-                                                          uint8_t bandIndex = 0);
+    static std::vector<WifiSpectrumBandIndices> ConvertHeRuSubcarriers(
+        MHz_u bandWidth,
+        MHz_u guardBandwidth,
+        const std::vector<MHz_u>& centerFrequencies,
+        MHz_u totalWidth,
+        Hz_u subcarrierSpacing,
+        HeRu::SubcarrierRange subcarrierRange,
+        uint8_t bandIndex = 0);
 
   protected:
     PhyFieldRxStatus ProcessSig(Ptr<Event> event,
@@ -465,8 +467,8 @@
     Ptr<Event> DoGetEvent(Ptr<const WifiPpdu> ppdu, RxPowerWattPerChannelBand& rxPowersW) override;
     bool IsConfigSupported(Ptr<const WifiPpdu> ppdu) const override;
     Time DoStartReceivePayload(Ptr<Event> event) override;
-    std::pair<uint16_t, WifiSpectrumBandInfo> GetChannelWidthAndBand(const WifiTxVector& txVector,
-                                                                     uint16_t staId) const override;
+    std::pair<MHz_u, WifiSpectrumBandInfo> GetChannelWidthAndBand(const WifiTxVector& txVector,
+                                                                  uint16_t staId) const override;
     void RxPayloadSucceeded(Ptr<const WifiPsdu> psdu,
                             RxSignalInfo rxSignalInfo,
                             const WifiTxVector& txVector,
@@ -480,7 +482,7 @@
     void DoAbortCurrentReception(WifiPhyRxfailureReason reason) override;
     uint64_t ObtainNextUid(const WifiTxVector& txVector) override;
     Time GetMaxDelayPpduSameUid(const WifiTxVector& txVector) override;
-    Ptr<SpectrumValue> GetTxPowerSpectralDensity(double txPowerW,
+    Ptr<SpectrumValue> GetTxPowerSpectralDensity(Watt_u txPower,
                                                  Ptr<const WifiPpdu> ppdu) const override;
     uint32_t GetMaxPsduSize() const override;
     WifiConstPsduMap GetWifiConstPsduMap(Ptr<const WifiPsdu> psdu,
@@ -542,16 +544,10 @@
     static uint64_t CalculateNonHtReferenceRate(WifiCodeRate codeRate, uint16_t constellationSize);
 
     /**
-     * \param channelWidth the channel width in MHz
+     * \param channelWidth the channel width
      * \return the number of usable subcarriers for data
      */
-    static uint16_t GetUsableSubcarriers(uint16_t channelWidth);
-
-    /**
-     * \param guardInterval the guard interval duration
-     * \return the symbol duration
-     */
-    static Time GetSymbolDuration(Time guardInterval);
+    static uint16_t GetUsableSubcarriers(MHz_u channelWidth);
 
     uint64_t m_previouslyTxPpduUid; //!< UID of the previously sent PPDU, used by AP to recognize
                                     //!< response HE TB PPDUs
@@ -575,12 +571,12 @@
     /**
      * This is a helper function to create the TX PSD of the non-HE and HE portions.
      *
-     * \param txPowerW power in W to spread across the bands
+     * \param txPower power to spread across the bands
      * \param ppdu the PPDU that will be transmitted
      * \param flag flag indicating whether the PSD is for non-HE portion or HE portion
      * \return Pointer to SpectrumValue
      */
-    Ptr<SpectrumValue> GetTxPowerSpectralDensity(double txPowerW,
+    Ptr<SpectrumValue> GetTxPowerSpectralDensity(Watt_u txPower,
                                                  Ptr<const WifiPpdu> ppdu,
                                                  HePpdu::TxPsdFlag flag) const;
 
@@ -588,12 +584,12 @@
      * Start the transmission of the HE portion of the MU PPDU.
      *
      * \param ppdu the PPDU
-     * \param txPowerDbm the total TX power in dBm
+     * \param txPower the total TX power
      * \param txPowerSpectrum the TX PSD
      * \param hePortionDuration the duration of the HE portion
      */
     void StartTxHePortion(Ptr<const WifiPpdu> ppdu,
-                          double txPowerDbm,
+                          dBm_u txPower,
                           Ptr<SpectrumValue> txPowerSpectrum,
                           Time hePortionDuration);
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/he-ppdu.cc ns-3.43/src/wifi/model/he/he-ppdu.cc
--- ns-3.42/src/wifi/model/he/he-ppdu.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/he-ppdu.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Rediet <getachew.redieteab@orange.com>
  *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
@@ -280,7 +269,7 @@
             }
             const auto ruBw = HeRu::GetBandwidth(ruType);
             auto primary80 = ruAllocIndex < 4;
-            auto num20MhzSubchannelsInRu = (ruBw < 20) ? 1 : (ruBw / 20);
+            const uint8_t num20MhzSubchannelsInRu = (ruBw < 20) ? 1 : (ruBw / 20);
             auto numRuAllocsInContentChannel = std::max(1, num20MhzSubchannelsInRu / 2);
             auto ruIndexOffset = (ruBw < 20) ? (ruSpecs.size() * ruAllocIndex)
                                              : (ruAllocIndex / num20MhzSubchannelsInRu);
@@ -316,7 +305,7 @@
     Time ppduDuration = Seconds(0);
     const auto& txVector = GetTxVector();
     const auto length = m_lSig.GetLength();
-    const auto tSymbol = NanoSeconds(12800 + txVector.GetGuardInterval());
+    const auto tSymbol = HePhy::GetSymbolDuration(txVector.GetGuardInterval());
     const auto preambleDuration = WifiPhy::CalculatePhyPreambleAndHeaderDuration(txVector);
     NS_ASSERT(m_operatingChannel.IsSet());
     uint8_t sigExtension = (m_operatingChannel.GetPhyBand() == WIFI_PHY_BAND_2_4GHZ) ? 6 : 0;
@@ -414,15 +403,15 @@
     return m_psdus.begin()->first;
 }
 
-uint16_t
+MHz_u
 HePpdu::GetTxChannelWidth() const
 {
     if (const auto& txVector = GetTxVector();
         txVector.IsValid() && txVector.IsUlMu() && GetStaId() != SU_STA_ID)
     {
         TxPsdFlag flag = GetTxPsdFlag();
-        uint16_t ruWidth = HeRu::GetBandwidth(txVector.GetRu(GetStaId()).GetRuType());
-        uint16_t channelWidth = (flag == PSD_NON_HE_PORTION && ruWidth < 20) ? 20 : ruWidth;
+        const auto ruWidth = HeRu::GetBandwidth(txVector.GetRu(GetStaId()).GetRuType());
+        MHz_u channelWidth = (flag == PSD_NON_HE_PORTION && ruWidth < 20) ? 20 : ruWidth;
         NS_LOG_INFO("Use channelWidth=" << channelWidth << " MHz for HE TB from " << GetStaId()
                                         << " for " << flag);
         return channelWidth;
@@ -483,7 +472,7 @@
 }
 
 std::pair<std::size_t, std::size_t>
-HePpdu::GetNumRusPerHeSigBContentChannel(uint16_t channelWidth,
+HePpdu::GetNumRusPerHeSigBContentChannel(MHz_u channelWidth,
                                          const RuAllocation& ruAllocation,
                                          bool sigBCompression,
                                          uint8_t numMuMimoUsers)
@@ -511,10 +500,11 @@
     }
 
     NS_ASSERT_MSG(!ruAllocation.empty(), "RU allocation is not set");
-    NS_ASSERT_MSG(ruAllocation.size() == channelWidth / 20,
+    [[maybe_unused]] const std::size_t num20MhzSubchannels = channelWidth / 20;
+    NS_ASSERT_MSG(ruAllocation.size() == num20MhzSubchannels,
                   "RU allocation is not consistent with packet bandwidth");
 
-    switch (channelWidth)
+    switch (static_cast<uint16_t>(channelWidth))
     {
     case 40:
         chSize.second += HeRu::GetRuSpecs(ruAllocation[1]).size();
@@ -636,7 +626,7 @@
 }
 
 uint32_t
-HePpdu::GetSigBFieldSize(uint16_t channelWidth,
+HePpdu::GetSigBFieldSize(MHz_u channelWidth,
                          const RuAllocation& ruAllocation,
                          bool sigBCompression,
                          std::size_t numMuMimoUsers)
@@ -692,7 +682,7 @@
 }
 
 uint8_t
-HePpdu::GetChannelWidthEncodingFromMhz(uint16_t channelWidth)
+HePpdu::GetChannelWidthEncodingFromMhz(MHz_u channelWidth)
 {
     if (channelWidth == 160)
     {
@@ -712,7 +702,7 @@
     }
 }
 
-uint16_t
+MHz_u
 HePpdu::GetChannelWidthMhzFromEncoding(uint8_t bandwidth)
 {
     if (bandwidth == 3)
@@ -734,17 +724,18 @@
 }
 
 uint8_t
-HePpdu::GetGuardIntervalAndNltfEncoding(uint16_t gi, uint8_t nltf)
+HePpdu::GetGuardIntervalAndNltfEncoding(Time guardInterval, uint8_t nltf)
 {
-    if (gi == 800 && nltf == 1)
+    const auto gi = guardInterval.GetNanoSeconds();
+    if ((gi == 800) && (nltf == 1))
     {
         return 0;
     }
-    else if (gi == 800 && nltf == 2)
+    else if ((gi == 800) && (nltf == 2))
     {
         return 1;
     }
-    else if (gi == 1600 && nltf == 2)
+    else if ((gi == 1600) && (nltf == 2))
     {
         return 2;
     }
@@ -754,21 +745,21 @@
     }
 }
 
-uint16_t
+Time
 HePpdu::GetGuardIntervalFromEncoding(uint8_t giAndNltfSize)
 {
     if (giAndNltfSize == 3)
     {
         // we currently do not consider DCM nor STBC fields
-        return 3200;
+        return NanoSeconds(3200);
     }
     else if (giAndNltfSize == 2)
     {
-        return 1600;
+        return NanoSeconds(1600);
     }
     else
     {
-        return 800;
+        return NanoSeconds(800);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/he-ppdu.h ns-3.43/src/wifi/model/he/he-ppdu.h
--- ns-3.42/src/wifi/model/he/he-ppdu.h	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/he-ppdu.h	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Rediet <getachew.redieteab@orange.com>
  *         Muhammad Iqbal Rochman <muhiqbalcr@uchicago.edu>
@@ -154,7 +143,7 @@
     Ptr<WifiPpdu> Copy() const override;
     WifiPpduType GetType() const override;
     uint16_t GetStaId() const override;
-    uint16_t GetTxChannelWidth() const override;
+    MHz_u GetTxChannelWidth() const override;
 
     /**
      * Get the payload of the PPDU.
@@ -193,14 +182,14 @@
      * This is applicable only for MU.
      * See section 27.3.10.8.3 of IEEE 802.11ax draft 4.0.
      *
-     * \param channelWidth the channel width occupied by the PPDU (in MHz)
+     * \param channelWidth the channel width occupied by the PPDU
      * \param ruAllocation 8 bit RU_ALLOCATION per 20 MHz
      * \param sigBCompression flag whether SIG-B compression is used by the PPDU
      * \param numMuMimoUsers the number of MU-MIMO users addressed by the PPDU
      * \return a pair containing the number of RUs in each HE-SIG-B content channel (resp. 1 and 2)
      */
     static std::pair<std::size_t, std::size_t> GetNumRusPerHeSigBContentChannel(
-        uint16_t channelWidth,
+        MHz_u channelWidth,
         const RuAllocation& ruAllocation,
         bool sigBCompression,
         uint8_t numMuMimoUsers);
@@ -218,13 +207,13 @@
 
     /**
      * Get variable length HE SIG-B field size
-     * \param channelWidth the channel width occupied by the PPDU (in MHz)
+     * \param channelWidth the channel width occupied by the PPDU
      * \param ruAllocation 8 bit RU_ALLOCATION per 20 MHz
      * \param sigBCompression flag whether SIG-B compression is used by the PPDU
      * \param numMuMimoUsers the number of MU-MIMO users addressed by the PPDU
      * \return field size in bytes
      */
-    static uint32_t GetSigBFieldSize(uint16_t channelWidth,
+    static uint32_t GetSigBFieldSize(MHz_u channelWidth,
                                      const RuAllocation& ruAllocation,
                                      bool sigBCompression,
                                      std::size_t numMuMimoUsers);
@@ -258,7 +247,7 @@
      * \param channelWidth the channel width in MHz
      * \return the value used to encode the bandwidth field in HE-SIG-A
      */
-    static uint8_t GetChannelWidthEncodingFromMhz(uint16_t channelWidth);
+    static uint8_t GetChannelWidthEncodingFromMhz(MHz_u channelWidth);
 
     /**
      * Convert number of spatial streams to NSTS field encoding in HE-SIG-A.
@@ -269,13 +258,13 @@
     static uint8_t GetNstsEncodingFromNss(uint8_t nss);
 
     /**
-     * Convert guard interval (in ns) and NLTF to its encoding in HE-SIG-A.
+     * Convert guard interval and NLTF to its encoding in HE-SIG-A.
      *
-     * \param gi the guard interval in nanoseconds
+     * \param guardInterval the guard interval
      * \param nltf the the number of long training symbols
      * \return the value used to encode the NSTS field in HE-SIG-A
      */
-    static uint8_t GetGuardIntervalAndNltfEncoding(uint16_t gi, uint8_t nltf);
+    static uint8_t GetGuardIntervalAndNltfEncoding(Time guardInterval, uint8_t nltf);
 
     /**
      * Convert number of spatial streams from NSTS field encoding in HE-SIG-A.
@@ -291,15 +280,15 @@
      * \param bandwidth the value of the bandwidth field in HE-SIG-A
      * \return the channel width in MHz
      */
-    static uint16_t GetChannelWidthMhzFromEncoding(uint8_t bandwidth);
+    static MHz_u GetChannelWidthMhzFromEncoding(uint8_t bandwidth);
 
     /**
-     * Convert guard interval (in ns) from its encoding in HE-SIG-A.
+     * Convert guard interval from its encoding in HE-SIG-A.
      *
      * \param giAndNltfSize the value used to encode the guard interval and NLTF field in HE-SIG-A
-     * \return the guard interval in nanoseconds
+     * \return the guard interval
      */
-    static uint16_t GetGuardIntervalFromEncoding(uint8_t giAndNltfSize);
+    static Time GetGuardIntervalFromEncoding(uint8_t giAndNltfSize);
 
     /**
      * Convert number of MU-MIMO users to its encoding in HE-SIG-A.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/he/he-ru.cc ns-3.43/src/wifi/model/he/he-ru.cc
--- ns-3.42/src/wifi/model/he/he-ru.cc	2024-05-29 15:29:47.200073700 -0700
+++ ns-3.43/src/wifi/model/he/he-ru.cc	2024-10-09 16:41:10.120656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -371,7 +360,7 @@
     // clang-format on
 };
 
-HeRu::RuSpecCompare::RuSpecCompare(uint16_t channelWidth, uint8_t p20Index)
+HeRu::RuSpecCompare::RuSpecCompare(MHz_u channelWidth, uint8_t p20Index)
     : m_channelWidth(channelWidth),
       m_p20Index(p20Index)
 {
@@ -476,7 +465,7 @@
 }
 
 std::size_t
-HeRu::RuSpec::GetPhyIndex(uint16_t bw, uint8_t p20Index) const
+HeRu::RuSpec::GetPhyIndex(MHz_u bw, uint8_t p20Index) const
 {
     bool primary80IsLower80 = (p20Index < bw / 40);
 
@@ -492,7 +481,7 @@
 }
 
 std::size_t
-HeRu::GetNRus(uint16_t bw, RuType ruType)
+HeRu::GetNRus(MHz_u bw, RuType ruType)
 {
     if (bw == 160 && ruType == RU_2x996_TONE)
     {
@@ -512,7 +501,7 @@
 }
 
 std::vector<HeRu::RuSpec>
-HeRu::GetRusOfType(uint16_t bw, HeRu::RuType ruType)
+HeRu::GetRusOfType(MHz_u bw, HeRu::RuType ruType)
 {
     if (ruType == HeRu::RU_2x996_TONE)
     {
@@ -542,7 +531,7 @@
 }
 
 std::vector<HeRu::RuSpec>
-HeRu::GetCentral26TonesRus(uint16_t bw, HeRu::RuType ruType)
+HeRu::GetCentral26TonesRus(MHz_u bw, HeRu::RuType ruType)
 {
     std::vector<std::size_t> indices;
 
@@ -588,7 +577,7 @@
 }
 
 HeRu::SubcarrierGroup
-HeRu::GetSubcarrierGroup(uint16_t bw, RuType ruType, std::size_t phyIndex)
+HeRu::GetSubcarrierGroup(MHz_u bw, RuType ruType, std::size_t phyIndex)
 {
     if (ruType == HeRu::RU_2x996_TONE) // handle special case of RU covering 160 MHz channel
     {
@@ -627,7 +616,7 @@
 }
 
 bool
-HeRu::DoesOverlap(uint16_t bw, RuSpec ru, const std::vector<RuSpec>& v)
+HeRu::DoesOverlap(MHz_u bw, RuSpec ru, const std::vector<RuSpec>& v)
 {
     // A 2x996-tone RU spans 160 MHz, hence it overlaps with any other RU
     if (bw == 160 && ru.GetRuType() == RU_2x996_TONE && !v.empty())
@@ -663,7 +652,7 @@
 }
 
 bool
-HeRu::DoesOverlap(uint16_t bw, RuSpec ru, const SubcarrierGroup& toneRanges, uint8_t p20Index)
+HeRu::DoesOverlap(MHz_u bw, RuSpec ru, const SubcarrierGroup& toneRanges, uint8_t p20Index)
 {
     for (const auto& range : toneRanges)
     {
@@ -686,7 +675,7 @@
 }
 
 HeRu::RuSpec
-HeRu::FindOverlappingRu(uint16_t bw, RuSpec referenceRu, RuType searchedRuType)
+HeRu::FindOverlappingRu(MHz_u bw, RuSpec referenceRu, RuType searchedRuType)
 {
     std::size_t numRus = HeRu::GetNRus(bw, searchedRuType);
 
@@ -763,7 +752,7 @@
     return os;
 }
 
-uint16_t
+MHz_u
 HeRu::GetBandwidth(RuType ruType)
 {
     switch (ruType)
@@ -789,9 +778,9 @@
 }
 
 HeRu::RuType
-HeRu::GetRuType(uint16_t bandwidth)
+HeRu::GetRuType(MHz_u bandwidth)
 {
-    switch (bandwidth)
+    switch (static_cast<uint16_t>(bandwidth))
     {
     case 2:
         return RU_26_TONE;
@@ -814,7 +803,7 @@
 }
 
 HeRu::RuType
-HeRu::GetEqualSizedRusForStations(uint16_t bandwidth,
+HeRu::GetEqualSizedRusForStations(MHz_u bandwidth,
                                   std::size_t& nStations,
                                   std::size_t& nCentral26TonesRus)
 {
